size(7cm);
import geometry;

int n = 8;

point ppX[];
ppX.push((-2.7, -1.8));

for(int i = 1; i < n; ++i) {
    point p = ppX[i-1];
    if(p.x < 1 && p.y < -1)
    {
        ppX.push((2 * (1) - p.x, 2 * (-1) - p.y));
    }
    if(p.x > 1 && p.y < 1)
    {
        ppX.push((2 * (1) - p.x, 2 * (1) - p.y));
    }
    if(p.x > -1 && p.y > 1)
    {
        ppX.push((2 * (-1) - p.x, 2 * (1) - p.y));
    }
    if(p.x < -1 && p.y > -1)
    {
        ppX.push((2 * (-1) - p.x, 2 * (-1) - p.y));
    }
}
ppX.cyclic = true;

picture markerground;

pen
    grayfill = gray(6/7),
    mainline = black+linewidth(1),
    dotcolor = black,
    moveline = dotcolor,
    varcolors[] = new pen[]{
        heavyred, olive, deepgreen,
        deepcyan, heavyblue, heavymagenta };

varcolors.cyclic = true;

pen varcolor(int i) {
    return varcolors[i];
}

dot(ppX, dotcolor);
label("$X$", ppX[0], S);
for(int i = 0; i < n; ++i) {
    draw(
        ppX[i] -- ppX[i+1],
        moveline, Arrow(2mm), Margin(3/5)
    );
    draw(
        markerground,
        ppX[i] -- ppX[i+1],
        invisible,
        StickIntervalMarker( 2, i+1, size=1mm, space=1mm,
            varcolor(i)+linewidth(1) )
    );
}

point pp_sq[] = new point[] {
    (-1, -1),
    (1, -1),
    (1, 1),
    (-1, 1),
};

filldraw(pp_sq[0]--pp_sq[1]--pp_sq[2]--pp_sq[3]--cycle, grayfill, mainline);
dot(pp_sq, Fill(grayfill));

add(markerground, above=true);
